searchData={"items":[{"type":"module","title":"tuncer","doc":"tuncer manages tuntap devices.","ref":"tuncer.html"},{"type":"function","title":"tuncer.broadcast/2","doc":"Configure the broadcast address for a TUN/TAP device. Support * Linux (IPv4 addresses only) Examples 1 &gt; { ok , Dev } = tuncer : create ( &quot;tun0&quot; , [ tun , no_pi , { active , false } ] ) . { ok , &lt; 0.205 . 0 &gt; } 2 &gt; tuncer : up ( Dev , &quot;10.1.1.1&quot; ) . ok 3 &gt; tuncer : broadcast ( Dev , &quot;10.1.1.3&quot; ) . ok 6 : tun0 : &lt; POINTOPOINT , MULTICAST , NOARP , UP , LOWER_UP &gt; mtu 1500 qdisc pfifo_fast state UNKNOWN group default qlen 500 link / none inet 10.1 . 1.1 / 32 brd 10.1 . 1.3 scope global tun0 valid_lft forever preferred_lft forever inet6 fe80 : : 9 d37 : 9 d1 : efba : 75 a1 / 64 scope link stable - privacy valid_lft forever preferred_lft forever","ref":"tuncer.html#broadcast/2"},{"type":"function","title":"tuncer.controlling_process/2","doc":"Change the controlling process of the TUN/TAP device. Change the process owning the socket. Allows another process to send and receive packets from the TUN/TAP device.","ref":"tuncer.html#controlling_process/2"},{"type":"function","title":"tuncer.create/0","doc":"Create the tap0 device. Examples 1 &gt; tuncer : create ( ) . { ok , &lt; 0.175 . 0 &gt; } $ ip link show tap0 2 : tap0 : &lt; BROADCAST , MULTICAST &gt; mtu 1500 qdisc noop state DOWN mode DEFAULT group default qlen 1000 link / ether 32 : a9 : 6 a : 5 b : 48 : c3 brd ff : ff : ff : ff : ff : ff","ref":"tuncer.html#create/0"},{"type":"function","title":"tuncer.create/1","doc":"Create a named tap device. Examples 1 &gt; tuncer : create ( &quot;foo&quot; ) . { ok , &lt; 0.175 . 0 &gt; } $ ip link show foo 3 : foo : &lt; BROADCAST , MULTICAST &gt; mtu 1500 qdisc noop state DOWN mode DEFAULT group default qlen 1000 link / ether 9 e : f1 : 90 : e2 : 2 c : 66 brd ff : ff : ff : ff : ff : ff","ref":"tuncer.html#create/1"},{"type":"function","title":"tuncer.create/2","doc":"Create a tuntap device. Device is the TUN/TAP device name. If a device name is empty, the TUN/TAP driver will choose one (for tap devices, starting from tap0 ; for tun devices, beginning from tun0 ). When the device is in {active, true} mode, data is sent as messages: {tuntap, PID, binary()} If an error is encountered: {tuntap_error, PID, posix()} Retrieving data from devices in {active, false} mode can be done using recv/1,2 or read/1,2. Options contains a list of flags. tun: create a tun interface tap: create a tap interface no_pi: do not prepend the data with a 4 byte header describing the physical interface The options default to [tap, no_pi, {active, false}] . Examples 1 &gt; tuncer : create ( &quot;tun0&quot; , [ tun , no_pi , { active , false } ] ) . { ok , &lt; 0.181 . 0 &gt; } $ ip link show tun0 4 : tun0 : &lt; POINTOPOINT , MULTICAST , NOARP &gt; mtu 1500 qdisc noop state DOWN mode DEFAULT group default qlen 500 link / none","ref":"tuncer.html#create/2"},{"type":"function","title":"tuncer.destroy/1","doc":"Remove the TUN/TAP device. Examples 1 &gt; { ok , Dev } = tuncer : create ( ) . { ok , &lt; 0.175 . 0 &gt; } 2 &gt; tuncer : destroy ( Dev ) . ok","ref":"tuncer.html#destroy/1"},{"type":"function","title":"tuncer.devname/1","doc":"Get the TUN/TAP device name. Examples 1 &gt; { ok , Dev } = tuncer : create ( ) . { ok , &lt; 0.175 . 0 &gt; } 2 &gt; tuncer : devname ( Dev ) . &lt;&lt; &quot;tap0&quot; &gt;&gt;","ref":"tuncer.html#devname/1"},{"type":"function","title":"tuncer.down/1","doc":"Unconfigure a TUN/TAP device. Examples 1 &gt; { ok , Dev } = tuncer : create ( &quot;tun0&quot; , [ tun , no_pi , { active , false } ] ) . { ok , &lt; 0.205 . 0 &gt; } 2 &gt; tuncer : up ( Dev , &quot;10.1.1.1&quot; ) . ok 3 &gt; tuncer : down ( Dev ) . ok","ref":"tuncer.html#down/1"},{"type":"function","title":"tuncer.dstaddr/2","doc":"Configure the remote address for a TUN/TAP device in point-to-point mode. Support * Linux (IPv4 addresses only) Examples 1 &gt; { ok , Dev } = tuncer : create ( &quot;tun0&quot; , [ tun , no_pi , { active , false } ] ) . { ok , &lt; 0.197 . 0 &gt; } 2 &gt; tuncer : up ( Dev , &quot;10.1.1.1&quot; ) . ok 3 &gt; tuncer : dstaddr ( Dev , &quot;10.1.1.2&quot; ) . ok $ ip a show tun0 4 : tun0 : &lt; POINTOPOINT , MULTICAST , NOARP , NOTRAILERS , UP , LOWER_UP &gt; mtu 1500 qdisc pfifo_fast state UNKNOWN group default qlen 500 link / none inet 10.1 . 1.1 peer 10.1 . 1.2 / 32 scope global tun0 valid_lft forever preferred_lft forever inet6 fe80 : : e0f7 : c90f : e2d8 : 91 e8 / 64 scope link stable - privacy valid_lft forever preferred_lft forever","ref":"tuncer.html#dstaddr/2"},{"type":"function","title":"tuncer.flags/1","doc":"Returns an integer holding the interface creation flags. Examples 1 &gt; { ok , Dev } = tuncer : create ( ) . { ok , &lt; 0.175 . 0 &gt; } 2 &gt; tuncer : flags ( Dev ) . [ tap , no_pi ]","ref":"tuncer.html#flags/1"},{"type":"function","title":"tuncer.getfd/1","doc":"Get TUN/TAP device file descriptor. Get the file descriptor associated with the process. Use getfd/1 with read/1,2 and write/2 to interact directly with the tuntap device (bypassing the gen_server). Examples 1 &gt; { ok , Dev } = tuncer : create ( ) . { ok , &lt; 0.175 . 0 &gt; } 2 &gt; tuncer : getfd ( Dev ) . 22","ref":"tuncer.html#getfd/1"},{"type":"function","title":"tuncer.group/2","doc":"Set the GID owning the interface. Support * Linux Examples 1 &gt; { ok , Dev } = tuncer : create ( ) . { ok , &lt; 0.201 . 0 &gt; } 2 &gt; tuncer : group ( Dev , 1000 ) . ok","ref":"tuncer.html#group/2"},{"type":"function","title":"tuncer.header/1","doc":"Parse TUN/TAP packet header. Examples 1 &gt; { ok , Dev } = tuncer : create ( &quot;tun0&quot; , [ tun , no_pi , { active , false } ] ) . { ok , &lt; 0.205 . 0 &gt; } 2 &gt; tuncer : up ( Dev , &quot;10.1.1.1&quot; ) . ok 3 &gt; { ok , Bin } = tuncer : recv ( Dev ) . { ok , &lt;&lt; 96 , 0 , 0 , 0 , 0 , 8 , 58 , 255 , 254 , 128 , 0 , 0 , 0 , 0 , 0 , 0 , 247 , 188 , 77 , 238 , 78 , 171 , 184 , 107 , 255 , 2 , 0 , . . . &gt;&gt; } 4 &gt; tuncer : header ( Bin ) . { tun_pi , 96 , 0 , &lt;&lt; 0 , 8 , 58 , 255 , 254 , 128 , 0 , 0 , 0 , 0 , 0 , 0 , 247 , 188 , 77 , 238 , 78 , 171 , 184 , 107 , 255 , 2 , 0 , 0 , 0 , . . . &gt;&gt; }","ref":"tuncer.html#header/1"},{"type":"function","title":"tuncer.mtu/1","doc":"Get the MTU (maximum transmission unit) for the TUN/TAP device. Examples 1 &gt; { ok , Dev } = tuncer : create ( &quot;tun0&quot; , [ tun , no_pi , { active , false } ] ) . { ok , &lt; 0.205 . 0 &gt; } 2 &gt; tuncer : up ( Dev , &quot;10.1.1.1&quot; ) . ok 3 &gt; tuncer : mtu ( Dev ) . 1500","ref":"tuncer.html#mtu/1"},{"type":"function","title":"tuncer.mtu/2","doc":null,"ref":"tuncer.html#mtu/2"},{"type":"function","title":"tuncer.owner/2","doc":"Set the UID owning the interface. Support * Linux Examples 1 &gt; { ok , Dev } = tuncer : create ( ) . { ok , &lt; 0.201 . 0 &gt; } 2 &gt; tuncer : owner ( Dev , 1000 ) . ok","ref":"tuncer.html#owner/2"},{"type":"function","title":"tuncer.persist/2","doc":"Set the interface to exist after the Erlang process exits. Support * Linux Examples 1 &gt; { ok , Dev } = tuncer : create ( ) . { ok , &lt; 0.201 . 0 &gt; } 2 &gt; tuncer : persist ( Dev , true ) . ok","ref":"tuncer.html#persist/2"},{"type":"function","title":"tuncer.read/1","doc":"Read data from the tuntap device file descriptor. Examples 1 &gt; { ok , Dev } = tuncer : create ( &quot;tun0&quot; , [ tun , no_pi , { active , false } ] ) . { ok , &lt; 0.197 . 0 &gt; } 2 &gt; tuncer : up ( Dev , &quot;10.1.1.1&quot; ) . ok 3 &gt; FD = tuncer : getfd ( Dev ) . 22 4 &gt; tuncer : read ( FD ) . { ok , &lt;&lt; 96 , 0 , 0 , 0 , 0 , 8 , 58 , 255 , 254 , 128 , 0 , 0 , 0 , 0 , 0 , 0 , 36 , 14 , 228 , 30 , 140 , 106 , 15 , 112 , 255 , 2 , 0 , . . . &gt;&gt; }","ref":"tuncer.html#read/1"},{"type":"function","title":"tuncer.read/2","doc":"Read up to the specified number of bytes from the tuntap device file descriptor. Examples 1 &gt; { ok , Dev } = tuncer : create ( &quot;tun0&quot; , [ tun , no_pi , { active , false } ] ) . { ok , &lt; 0.197 . 0 &gt; } 2 &gt; tuncer : up ( Dev , &quot;10.1.1.1&quot; ) . ok 3 &gt; FD = tuncer : getfd ( Dev ) . 22 4 &gt; tuncer : read ( FD , 16 ) . { ok , &lt;&lt; 96 , 0 , 0 , 0 , 0 , 8 , 58 , 255 , 254 , 128 , 0 , 0 , 0 , 0 , 0 , 0 &gt;&gt; }","ref":"tuncer.html#read/2"},{"type":"function","title":"tuncer.recv/1","doc":"Read data to the tuntap device. Examples 1 &gt; { ok , Dev } = tuncer : create ( &quot;tun0&quot; , [ tun , no_pi , { active , false } ] ) . { ok , &lt; 0.205 . 0 &gt; } 2 &gt; tuncer : up ( Dev , &quot;10.1.1.1&quot; ) . ok 3 &gt; { ok , D } = tuncer : recv ( Dev ) . { ok , &lt;&lt; 96 , 0 , 0 , 0 , 0 , 8 , 58 , 255 , 254 , 128 , 0 , 0 , 0 , 0 , 0 , 0 , 89 , 201 , 218 , 161 , 25 , 116 , 199 , 243 , 255 , 2 , 0 , . . . &gt;&gt; }","ref":"tuncer.html#recv/1"},{"type":"function","title":"tuncer.recv/2","doc":"Read up to the specified number of bytes from the tuntap device. Examples 1 &gt; { ok , Dev } = tuncer : create ( &quot;tun0&quot; , [ tun , no_pi , { active , false } ] ) . { ok , &lt; 0.205 . 0 &gt; } 2 &gt; tuncer : up ( Dev , &quot;10.1.1.1&quot; ) . ok 3 &gt; tuncer : recv ( Dev , 16 ) . { ok , &lt;&lt; 96 , 0 , 0 , 0 , 0 , 8 , 58 , 255 , 254 , 128 , 0 , 0 , 0 , 0 , 0 , 0 &gt;&gt; }","ref":"tuncer.html#recv/2"},{"type":"function","title":"tuncer.send/2","doc":"Write data to the tuntap device. Examples 1 &gt; { ok , Dev } = tuncer : create ( &quot;tun0&quot; , [ tun , no_pi , { active , false } ] ) . { ok , &lt; 0.205 . 0 &gt; } 2 &gt; tuncer : up ( Dev , &quot;10.1.1.1&quot; ) . ok 3 &gt; { ok , Data } = tuncer : recv ( Dev ) . { ok , &lt;&lt; 96 , 0 , 0 , 0 , 0 , 8 , 58 , 255 , 254 , 128 , 0 , 0 , 0 , 0 , 0 , 0 , 89 , 201 , 218 , 161 , 25 , 116 , 199 , 243 , 255 , 2 , 0 , . . . &gt;&gt; } 4 &gt; tuncer : send ( Dev , Data ) . ok","ref":"tuncer.html#send/2"},{"type":"function","title":"tuncer.setopt/2","doc":"Set TUN/TAP device option. setopt/2 currently supports toggling active mode for performing flow control. Examples 1 &gt; { ok , Dev } = tuncer : create ( &quot;tun0&quot; , [ tun , no_pi , { active , false } ] ) . { ok , &lt; 0.205 . 0 &gt; } 2 &gt; tuncer : up ( Dev , &quot;10.1.1.1&quot; ) . ok 3 &gt; tuncer : setopt ( Dev , { active , true } ) . ok 4 &gt; tuncer : setopt ( Dev , { active , false } ) . ok 5 &gt; flush ( ) . Shell got { tuntap , &lt; 0.205 . 0 &gt; , &lt;&lt; 96 , 0 , 0 , 0 , 0 , 8 , 58 , 255 , 254 , 128 , 0 , 0 , 0 , 0 , 0 , 0 , 44 , 191 , 1 , 21 , 92 , 149 , 243 , 132 , 255 , 2 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 2 , 133 , 0 , 255 , 72 , 0 , 0 , 0 , 0 &gt;&gt; } Shell got { tuntap , &lt; 0.205 . 0 &gt; , &lt;&lt; 96 , 0 , 0 , 0 , 0 , 8 , 58 , 255 , 254 , 128 , 0 , 0 , 0 , 0 , 0 , 0 , 44 , 191 , 1 , 21 , 92 , 149 , 243 , 132 , 255 , 2 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 2 , 133 , 0 , 255 , 72 , 0 , 0 , 0 , 0 &gt;&gt; } Shell got { tuntap , &lt; 0.205 . 0 &gt; , &lt;&lt; 96 , 0 , 0 , 0 , 0 , 8 , 58 , 255 , 254 , 128 , 0 , 0 , 0 , 0 , 0 , 0 , 44 , 191 , 1 , 21 , 92 , 149 , 243 , 132 , 255 , 2 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 2 , 133 , 0 , 255 , 72 , 0 , 0 , 0 , 0 &gt;&gt; } ok","ref":"tuncer.html#setopt/2"},{"type":"function","title":"tuncer.up/2","doc":"Configure a TUN/TAP device using the default netmask and broadcast for the network. Examples 1 &gt; { ok , Dev } = tuncer : create ( ) . { ok , &lt; 0.201 . 0 &gt; } 2 &gt; tuncer : up ( Dev , &quot;127.8.8.8&quot; ) . ok # ip a show dev tap0 7 : tap0 : &lt; BROADCAST , MULTICAST , UP , LOWER_UP &gt; mtu 1500 qdisc pfifo_fast state UNKNOWN group default qlen 1000 link / ether 6 e : fb : 29 : 46 : df : 00 brd ff : ff : ff : ff : ff : ff inet 127.8 . 8.8 / 32 brd 127.255 . 255.255 scope host tap0 valid_lft forever preferred_lft forever inet6 fe80 : : 6 cfb : 29 ff : fe46 : df00 / 64 scope link valid_lft forever preferred_lft forever","ref":"tuncer.html#up/2"},{"type":"function","title":"tuncer.up/3","doc":"Configure a TUN/TAP device. Examples 1 &gt; { ok , Dev } = tuncer : create ( &quot;tun0&quot; , [ tun , no_pi , { active , false } ] ) . { ok , &lt; 0.197 . 0 &gt; } 2 &gt; tuncer : up ( Dev , &quot;10.1.1.1&quot; , 24 ) . ok 16 : tun0 : &lt; POINTOPOINT , MULTICAST , NOARP , UP , LOWER_UP &gt; mtu 1500 qdisc pfifo_fast state UNKNOWN group default qlen 500 link / none inet 10.1 . 1.1 / 24 scope global tun0 valid_lft forever preferred_lft forever inet6 fe80 : : 5472 : aa66 : 7 afa : 64 b9 / 64 scope link stable - privacy valid_lft forever preferred_lft forever","ref":"tuncer.html#up/3"},{"type":"function","title":"tuncer.write/2","doc":"Write data to the tuntap device file descriptor. Examples 1 &gt; { ok , Dev } = tuncer : create ( &quot;tun0&quot; , [ tun , no_pi , { active , false } ] ) . { ok , &lt; 0.205 . 0 &gt; } 2 &gt; tuncer : up ( Dev , &quot;10.1.1.1&quot; ) . ok 3 &gt; FD = tuncer : getfd ( Dev ) . 22 4 &gt; { ok , Data } = tuncer : read ( FD , 16 ) . { ok , &lt;&lt; 96 , 0 , 0 , 0 , 0 , 8 , 58 , 255 , 254 , 128 , 0 , 0 , 0 , 0 , 0 , 0 &gt;&gt; } 6 &gt; tuncer : write ( FD , Data ) . ok","ref":"tuncer.html#write/2"},{"type":"type","title":"tuncer.dev/0","doc":null,"ref":"tuncer.html#t:dev/0"},{"type":"behaviour","title":"tunctl","doc":"tunctl is an Erlang API for creating and using TUN/TAP interfaces. tunctl does the actual tun/tap device manipulation. Some functions take a device name, others a file descriptor. It is up to the caller to make sure the file descriptors are closed (the device will disappear after the fd is closed if the device is not persistent).","ref":"tunctl.html"},{"type":"function","title":"tunctl.broadcast/2","doc":"Configure the broadcast address for a TUN/TAP device. Support * Linux (IPv4 addresses only) Examples 1 &gt; { ok , FD , Dev } = tunctl : create ( &lt;&lt; &quot;tuncer&quot; &gt;&gt; ) . { ok , 22 , &lt;&lt; &quot;tuncer&quot; &gt;&gt; } 2 &gt; tunctl : up ( Dev , { 127 , 8 , 8 , 1 } ) . ok 3 &gt; tunctl : broadcast ( Dev , { 127 , 8 , 8 , 3 } ) . ok 28 : tuncer : &lt; BROADCAST , MULTICAST , UP , LOWER_UP &gt; mtu 1500 qdisc pfifo_fast state UNKNOWN group default qlen 1000 link / ether 6 e : f2 : e9 : 31 : d4 : 3 a brd ff : ff : ff : ff : ff : ff inet 127.8 . 8.1 / 32 brd 127.8 . 8.3 scope host tuncer valid_lft forever preferred_lft forever inet6 fe80 : : 6 cf2 : e9ff : fe31 : d43a / 64 scope link valid_lft forever preferred_lft forever","ref":"tunctl.html#broadcast/2"},{"type":"function","title":"tunctl.create/0","doc":"Create the tap0 device. Examples 1 &gt; tunctl : create ( ) . { ok , 22 , &lt;&lt; &quot;tap0&quot; &gt;&gt; } $ ip link show tap0 17 : tap0 : &lt; BROADCAST , MULTICAST &gt; mtu 1500 qdisc noop state DOWN mode DEFAULT group default qlen 1000 link / ether 16 : ae : f3 : 36 : be : 3 f brd ff : ff : ff : ff : ff : ff","ref":"tunctl.html#create/0"},{"type":"function","title":"tunctl.create/1","doc":"Create a named tap device. Examples 1 &gt; tunctl : create ( &lt;&lt; &quot;tuncer&quot; &gt;&gt; ) . { ok , 22 , &lt;&lt; &quot;tuncer&quot; &gt;&gt; } $ ip link show tuncer 18 : tuncer : &lt; BROADCAST , MULTICAST &gt; mtu 1500 qdisc noop state DOWN mode DEFAULT group default qlen 1000 link / ether 9 e : bf : d9 : 4 a : 06 : 72 brd ff : ff : ff : ff : ff : ff","ref":"tunctl.html#create/1"},{"type":"function","title":"tunctl.create/2","doc":"Create a tuntap device. Device is the TUN/TAP device name. If a device name is empty, the TUN/TAP driver will choose one (for tap devices, starting from tap0 ; for tun devices, beginning from tun0 ). Options contains a list of flags. tun: create a tun interface tap: create a tap interface no_pi: do not prepend the data with a 4 byte header describing the physical interface The options default to [tap, no_pi, {active, false}] . Examples 1 &gt; tunctl : create ( &lt;&lt; &quot;tuncer&quot; &gt;&gt; , [ tun , no_pi ] ) . { ok , 22 , &lt;&lt; &quot;tuncer&quot; &gt;&gt; } $ ip link show tun0 19 : tuncer : &lt; POINTOPOINT , MULTICAST , NOARP &gt; mtu 1500 qdisc noop state DOWN mode DEFAULT group default qlen 500 link / none","ref":"tunctl.html#create/2"},{"type":"callback","title":"tunctl.create/2","doc":null,"ref":"tunctl.html#c:create/2"},{"type":"function","title":"tunctl.down/1","doc":"Unconfigure a TUN/TAP device. Examples 1 &gt; { ok , FD , Dev } = tunctl : create ( &lt;&lt; &quot;tuncer&quot; &gt;&gt; ) . { ok , 22 , &lt;&lt; &quot;tuncer&quot; &gt;&gt; } 2 &gt; tunctl : up ( Dev , { 127 , 8 , 8 , 1 } ) . ok 4 &gt; tunctl : down ( Dev ) . ok","ref":"tunctl.html#down/1"},{"type":"function","title":"tunctl.dstaddr/2","doc":"Configure the remote address for a TUN/TAP device in point-to-point mode. Support * Linux (IPv4 addresses only) Examples 1 &gt; { ok , FD , Dev } = tunctl : create ( &lt;&lt; &quot;tuncer&quot; &gt;&gt; ) . { ok , 22 , &lt;&lt; &quot;tuncer&quot; &gt;&gt; } 2 &gt; tunctl : up ( Dev , { 127 , 8 , 8 , 1 } ) . ok 3 &gt; tunctl : dstaddr ( Dev , { 127 , 8 , 8 , 2 } ) . ok $ ip a show tun0 26 : tuncer : &lt; BROADCAST , MULTICAST , NOTRAILERS , UP , LOWER_UP &gt; mtu 1500 qdisc pfifo_fast state UNKNOWN group default qlen 1000 link / ether 8 a : 0 f : 74 : 4 e : 5 e : 1 c brd ff : ff : ff : ff : ff : ff inet 127.8 . 8.1 peer 127.8 . 8.2 / 32 brd 127.255 . 255.255 scope host tuncer valid_lft forever preferred_lft forever inet6 fe80 : : 880 f : 74 ff : fe4e : 5 e1c / 64 scope link valid_lft forever preferred_lft forever","ref":"tunctl.html#dstaddr/2"},{"type":"function","title":"tunctl.group/2","doc":"Set the GID owning the interface. Support * Linux Examples 1 &gt; { ok , FD , Dev } = tunctl : create ( &lt;&lt; &quot;tuncer&quot; &gt;&gt; ) . { ok , 22 , &lt;&lt; &quot;tuncer&quot; &gt;&gt; } 2 &gt; tunctl : group ( FD , 1000 ) . ok","ref":"tunctl.html#group/2"},{"type":"callback","title":"tunctl.group/2","doc":null,"ref":"tunctl.html#c:group/2"},{"type":"function","title":"tunctl.header/1","doc":"Parse TUN/TAP packet header. Examples 1 &gt; { ok , FD , Dev } = tunctl : create ( &lt;&lt; &quot;tuncer&quot; &gt;&gt; ) . { ok , 22 , &lt;&lt; &quot;tuncer&quot; &gt;&gt; } 2 &gt; tunctl : up ( Dev , { 127 , 8 , 8 , 1 } ) . ok 3 &gt; { ok , Bin } = procket : read ( FD , 1024 ) . { ok , &lt;&lt; 51 , 51 , 0 , 0 , 0 , 22 , 254 , 45 , 152 , 87 , 204 , 21 , 134 , 221 , 96 , 0 , 0 , 0 , 0 , 36 , 0 , 1 , 0 , 0 , 0 , 0 , 0 , . . . &gt;&gt; } 4 &gt; tunctl : header ( Bin ) . { tun_pi , 13107 , 0 , &lt;&lt; 0 , 22 , 254 , 45 , 152 , 87 , 204 , 21 , 134 , 221 , 96 , 0 , 0 , 0 , 0 , 36 , 0 , 1 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , . . . &gt;&gt; }","ref":"tunctl.html#header/1"},{"type":"function","title":"tunctl.mtu/3","doc":"Set the MTU (maximum transmission unit) for the TUN/TAP device. Examples 1 &gt; { ok , FD , Dev } = tunctl : create ( &lt;&lt; &quot;tuncer&quot; &gt;&gt; ) . { ok , 22 , &lt;&lt; &quot;tuncer&quot; &gt;&gt; } 2 &gt; tunctl : up ( Dev , { 127 , 8 , 8 , 1 } ) . ok 3 &gt; tunctl : mtu ( FD , Dev , 1400 ) . { ok , 22 , &lt;&lt; &quot;tuncer&quot; &gt;&gt; }","ref":"tunctl.html#mtu/3"},{"type":"function","title":"tunctl.owner/2","doc":"Set the UID owning the interface. Support * Linux Examples 1 &gt; { ok , FD , Dev } = tunctl : create ( &lt;&lt; &quot;tuncer&quot; &gt;&gt; ) . { ok , 22 , &lt;&lt; &quot;tuncer&quot; &gt;&gt; } 2 &gt; tunctl : owner ( FD , 1000 ) . ok","ref":"tunctl.html#owner/2"},{"type":"callback","title":"tunctl.owner/2","doc":null,"ref":"tunctl.html#c:owner/2"},{"type":"function","title":"tunctl.persist/2","doc":"Set the interface to exist after the Erlang process exits. Support * Linux Examples 1 &gt; { ok , FD , Dev } = tunctl : create ( &lt;&lt; &quot;tuncer&quot; &gt;&gt; , [ tun , no_pi ] ) . { ok , 22 , &lt;&lt; &quot;tuncer&quot; &gt;&gt; } 3 &gt; tunctl : persist ( FD , true ) . ok","ref":"tunctl.html#persist/2"},{"type":"callback","title":"tunctl.persist/2","doc":null,"ref":"tunctl.html#c:persist/2"},{"type":"function","title":"tunctl.up/2","doc":"Configure a TUN/TAP device using the default netmask and broadcast for the network. Configure the interface just like ifconfig except with fewer features and no error checking. Examples 1 &gt; { ok , FD , Dev } = tunctl : create ( &lt;&lt; &quot;tuncer&quot; &gt;&gt; ) . { ok , 22 , &lt;&lt; &quot;tuncer&quot; &gt;&gt; } 2 &gt; tunctl : up ( Dev , { 127 , 8 , 8 , 8 } ) . ok $ ip a show dev tuncer 24 : tuncer : &lt; BROADCAST , MULTICAST , UP , LOWER_UP &gt; mtu 1500 qdisc pfifo_fast state UNKNOWN group default qlen 1000 link / ether 52 : 0 a : b2 : 71 : f2 : cd brd ff : ff : ff : ff : ff : ff inet 127.8 . 8.8 / 32 brd 127.255 . 255.255 scope host tuncer valid_lft forever preferred_lft forever inet6 fe80 : : 500 a : b2ff : fe71 : f2cd / 64 scope link valid_lft forever preferred_lft forever","ref":"tunctl.html#up/2"},{"type":"function","title":"tunctl.up/3","doc":"Configure a TUN/TAP device with a netmask. Examples 1 &gt; { ok , FD , Dev } = tunctl : create ( &lt;&lt; &quot;tuncer&quot; &gt;&gt; ) . { ok , 22 , &lt;&lt; &quot;tuncer&quot; &gt;&gt; } 2 &gt; tunctl : up ( Dev , { 127 , 8 , 8 , 8 } , 24 ) . ok $ ip a show dev tuncer 25 : tuncer : &lt; BROADCAST , MULTICAST , UP , LOWER_UP &gt; mtu 1500 qdisc pfifo_fast state UNKNOWN group default qlen 1000 link / ether 5 e : 6 a : 6 a : a2 : 67 : 0 f brd ff : ff : ff : ff : ff : ff inet 127.8 . 8.8 / 24 brd 127.8 . 8.255 scope host tuncer valid_lft forever preferred_lft forever inet6 fe80 : : 5 c6a : 6 aff : fea2 : 670 f / 64 scope link valid_lft forever preferred_lft forever","ref":"tunctl.html#up/3"},{"type":"type","title":"tunctl.fd/0","doc":null,"ref":"tunctl.html#t:fd/0"},{"type":"type","title":"tunctl.uint16_t/0","doc":null,"ref":"tunctl.html#t:uint16_t/0"},{"type":"module","title":"tunctl_darwin","doc":"tunctl behaviour for Mac OS X. Requires the tun/tap driver from: http://tuntaposx.sourceforge.net/ Allow the user running tunctl to call ifconfig using sudo: sudo visudo youruser ALL = NOPASSWD : / sbin / ifconfig tap * youruser ALL = NOPASSWD : / sbin / ifconfig tun *","ref":"tunctl_darwin.html"},{"type":"function","title":"tunctl_darwin.create/2","doc":null,"ref":"tunctl_darwin.html#create/2"},{"type":"function","title":"tunctl_darwin.group/2","doc":null,"ref":"tunctl_darwin.html#group/2"},{"type":"function","title":"tunctl_darwin.header/1","doc":null,"ref":"tunctl_darwin.html#header/1"},{"type":"function","title":"tunctl_darwin.owner/2","doc":null,"ref":"tunctl_darwin.html#owner/2"},{"type":"function","title":"tunctl_darwin.persist/2","doc":null,"ref":"tunctl_darwin.html#persist/2"},{"type":"module","title":"tunctl_freebsd","doc":"tunctl behaviour for FreeBSD. tunctl uses the FreeBSD tuntap legacy interface. 1. Ensure the tap device kernel module is loaded: $ kldstat $ kldload if_tap If you want the tap driver loaded on boot, add to /boot/loader.conf: if_tap_load = &quot;YES&quot; 2. Check cloning is enabled: $ sysctl net . link . tun . devfs_cloning net . link . tun . devfs_cloning : 1 $ sysctl net . link . tap . devfs_cloning net . link . tap . devfs_cloning : 1 3. Allow the user running tunctl to call ifconfig using sudo: sudo visudo youruser ALL = NOPASSWD : / sbin / ifconfig tap * youruser ALL = NOPASSWD : / sbin / ifconfig tun *","ref":"tunctl_freebsd.html"},{"type":"function","title":"tunctl_freebsd.create/2","doc":null,"ref":"tunctl_freebsd.html#create/2"},{"type":"function","title":"tunctl_freebsd.group/2","doc":null,"ref":"tunctl_freebsd.html#group/2"},{"type":"function","title":"tunctl_freebsd.header/1","doc":null,"ref":"tunctl_freebsd.html#header/1"},{"type":"function","title":"tunctl_freebsd.owner/2","doc":null,"ref":"tunctl_freebsd.html#owner/2"},{"type":"function","title":"tunctl_freebsd.persist/2","doc":null,"ref":"tunctl_freebsd.html#persist/2"},{"type":"module","title":"tunctl_linux","doc":"tunctl behaviour for Linux. For IPv4 addresses, beam needs to have privileges to configure interfaces. To add cap_net_admin capabilities: sudo setcap cap_net_admin = ep / path / to / bin / beam . smp To check the privileges: getcap / path / to / bin / beam . smp To remove the privileges: sudo setcap - r cap_net_admin = ep / path / to / bin / beam . smp Currently, IPv6 addresses are configured by calling ifconfig using sudo (see below).","ref":"tunctl_linux.html"},{"type":"function","title":"tunctl_linux.broadcast/2","doc":null,"ref":"tunctl_linux.html#broadcast/2"},{"type":"function","title":"tunctl_linux.create/2","doc":null,"ref":"tunctl_linux.html#create/2"},{"type":"function","title":"tunctl_linux.down/1","doc":null,"ref":"tunctl_linux.html#down/1"},{"type":"function","title":"tunctl_linux.dstaddr/2","doc":null,"ref":"tunctl_linux.html#dstaddr/2"},{"type":"function","title":"tunctl_linux.group/2","doc":null,"ref":"tunctl_linux.html#group/2"},{"type":"function","title":"tunctl_linux.header/1","doc":null,"ref":"tunctl_linux.html#header/1"},{"type":"function","title":"tunctl_linux.mtu/3","doc":null,"ref":"tunctl_linux.html#mtu/3"},{"type":"function","title":"tunctl_linux.owner/2","doc":null,"ref":"tunctl_linux.html#owner/2"},{"type":"function","title":"tunctl_linux.persist/2","doc":null,"ref":"tunctl_linux.html#persist/2"},{"type":"function","title":"tunctl_linux.up/3","doc":null,"ref":"tunctl_linux.html#up/3"},{"type":"module","title":"tunctl_netbsd","doc":"tunctl behaviour for NetBSD. NOTE: On NetBSD, tap(4) and tun(4) are separate drivers. The former, which this module deals with, is always no_pi . References: * https://man.netbsd.org/tap.4 * https://man.netbsd.org/tun.4","ref":"tunctl_netbsd.html"},{"type":"function","title":"tunctl_netbsd.create/2","doc":null,"ref":"tunctl_netbsd.html#create/2"},{"type":"function","title":"tunctl_netbsd.group/2","doc":null,"ref":"tunctl_netbsd.html#group/2"},{"type":"function","title":"tunctl_netbsd.owner/2","doc":null,"ref":"tunctl_netbsd.html#owner/2"},{"type":"function","title":"tunctl_netbsd.persist/2","doc":null,"ref":"tunctl_netbsd.html#persist/2"},{"type":"extras","title":"Overview","doc":"tunctl is an Erlang API for creating and using TUN/TAP interfaces.","ref":"readme.html"},{"type":"extras","title":"PRIVILEGES - Overview","doc":"#","ref":"readme.html#privileges"},{"type":"extras","title":"Linux - Overview","doc":"For IPv4 addresses, beam needs to have privileges to configure interfaces.\n\nTo add cap_net_admin capabilities:\n\n```\n sudo setcap cap_net_admin=ep /path/to/bin/beam.smp\n```\n\nTo check the privileges:\n\n```\n getcap /path/to/bin/beam.smp\n```\n\nTo remove the privileges:\n\n```\n sudo setcap -r cap_net_admin=ep /path/to/bin/beam.smp\n```\n\nCurrently, IPv6 addresses are configured by calling ifconfig using sudo\n(see below).\n\n#","ref":"readme.html#linux"},{"type":"extras","title":"Mac OS X - Overview","doc":"Requires the tun/tap driver from:\n\nhttp://tuntaposx.sourceforge.net/\n\nAllow the user running tunctl to call ifconfig using sudo:\n\n```\nsudo visudo\nyouruser ALL=NOPASSWD: /sbin/ifconfig tap*\nyouruser ALL=NOPASSWD: /sbin/ifconfig tun*\n```\n\n#","ref":"readme.html#mac-os-x"},{"type":"extras","title":"FreeBSD - Overview","doc":"tunctl uses the FreeBSD tuntap legacy interface.\n\n1. Ensure the tap device kernel module is loaded:\n\n   ```\n    $ kldstat\n    $ kldload if_tap\n   ```\n\n   If you want the tap driver loaded on boot, add to /boot/loader.conf:\n\n   ```\n    if_tap_load=\"YES\"\n   ```\n\n2. Check cloning is enabled:\n\n   ```\n    $ sysctl net.link.tun.devfs_cloning\n    net.link.tun.devfs_cloning: 1\n\n    $ sysctl net.link.tap.devfs_cloning\n    net.link.tap.devfs_cloning: 1\n   ```\n\n3. Allow the user running tunctl to call ifconfig using sudo:\n\n   ```\n    sudo visudo\n    youruser ALL=NOPASSWD: /sbin/ifconfig tap*\n    youruser ALL=NOPASSWD: /sbin/ifconfig tun*\n   ```","ref":"readme.html#freebsd"},{"type":"extras","title":"EXPORTS - Overview","doc":"#","ref":"readme.html#exports"},{"type":"extras","title":"tuncer - Overview","doc":"Tuncer is a stand up guy and just like him, tuncer has your back.\n\n```\ncreate() -> {ok, PID}\ncreate(Device) -> {ok, PID}\ncreate(Device, Options) -> {ok, PID}\n\n    Types   Device = [ string() | binary() ]\n            Options = [ Flag ]\n            Flag = [ tun | tap | no_pi | one_queue | multi_queue | vnet_hdr | tun_excl\n                    | {active, false} | {active, true} | {namespace, NameSpace} ]\n\n    Device is the TUN/TAP interface name. If an interface name is not\n    specified, the TUN/TAP driver will choose one (for tap devices,\n    starting from \"tap0\"; for tun devices, beginning from \"tun0\").\n\n    When the device is in {active, true} mode, data is sent as\n    messages:\n\n        {tuntap, PID, binary()}\n\n    If an error is encountered:\n\n        {tuntap_error, PID, posix()}\n\n    Retrieving data from devices in {active, false} mode can be done\n    using recv/1,2 or read/1,2.\n\n    Options contains a list of flags.\n\n        tun: create a tun interface\n\n        tap: create a tap interface\n\n        no_pi: do not prepend the data with a 4 byte header describing\n               the physical interface\n\n    The options default to [tap, no_pi, {active, false}].\n\ndestroy(Ref) -> ok\n\n    Types   Ref = pid()\n\n    Remove the TUN/TAP interface.\n\nsend(Ref, Data) -> ok | {error, posix()}\n\n    Types   Ref = pid()\n            Data = binary()\n\n    Write data to the tun/tap device.\n\nrecv(Ref) -> {ok, Buf} | {error, posix()}\nrecv(Ref, Size) -> {ok, Buf} | {error, posix()}\n\n    Types   Ref = pid()\n            Size = integer()\n            Buf = binary()\n\n    Read data from the tuntap interface.\n\n    If the device is in {active, true} mode, recv/1,2 will return\n    {error, einval}.\n\nsetopt(Ref, Option) -> ok | {error, posix()}\n\n    Types   Ref = pid()\n            Option = {active, true} | {active, false}\n\n    Set an option. setopt/2 can be used for performing flow control\n    when active mode is enabled.\n\ncontrolling_process(Ref, NewOwner) -> ok | {error, posix()}\n\n    Types   Ref = NewOwner = pid()\n\n    Transfer ownership of the tuntap device to another process.\n\nup(Ref, IP) -> ok | {error, posix()}\n\n    Types   Ref = pid()\n            IP = IPv4 | IPv6\n            IPv4 = list() | tuple()\n            IPv6 = list() | tuple()\n\n    Configure a TUN/TAP interface using the default netmask and broadcast\n    for the network.\n\ndown(Ref) -> ok | {error, posix()}\n\n    Types   Ref = pid()\n\n    Unconfigure a TUN/TAP interface.\n\ndstaddr(Ref, IP) -> ok | {error, posix()}\n\n    Types   Ref = pid()\n            IP = IPv4\n            IPv4 = list() | tuple()\n\n    Configure the remote address for a TUN/TAP interface in\n    point-to-point mode.\n\n    Currently only IPv4 addresses on Linux are supported.\n\nbroadcast(Ref, IP) -> ok | {error, posix()}\n\n    Types   Ref = pid()\n            IP = IPv4\n            IPv4 = list() | tuple()\n\n    Configure the broadcast address for a TUN/TAP interface.\n\n    Currently only IPv4 addresses on Linux are supported.\n\npersist(Ref, Boolean) -> ok | {error, posix()}\n\n    Types   Ref = pid()\n            Boolean = [ true | false ]\n\n    (Linux only)\n\n    Set the interface to exist after the Erlang process exits.\n\nowner(Ref, Owner) -> ok | {error, posix()}\n\n    Types   Ref = pid()\n            Owner = integer()\n\n    (Linux only)\n\n    Set the uid owning the interface.\n\ngroup(Ref, Group) -> ok | {error, posix()}\n\n    Types   Ref = pid()\n            Group = integer()\n\n    (Linux only)\n\n    Set the gid owning the interface.\n\ngetfd(Ref) -> integer()\n\n    Types   Ref = pid()\n\n    Get the file descriptor associated with the process. Use getfd/1\n    with read/1,2 and write/2 to interact directly with the tuntap device\n    (bypassing the gen_server).\n\nread(Fd) -> {ok, Buf} | {error, posix()}\nread(Fd, Size) -> {ok, Buf} | {error, posix()}\n\n    Types   Fd = integer()\n            Size = integer()\n            Buf = binary()\n\n    Read data from the tuntap interface.\n\nwrite(Fd, Buf) -> ok | {error, posix()}\n\n    Types   Ref = integer()\n            Buf = binary()\n\n    Write _Buf_ to the interface.\n\ndevname(Ref) -> Devname\n\n    Types   Devname = binary()\n\n    Returns the TUN/TAP device name.\n\nflags(Ref) -> integer()\n\n    Returns an integer holding the interface creation flags.\n```\n\n#","ref":"readme.html#tuncer"},{"type":"extras","title":"tunctl - Overview","doc":"tunctl does the actual tun/tap device manipulation. Some functions take\na device name, others a file descriptor. It is up to the caller to make\nsure the file descriptors are closed (the device will disappear after\nthe fd is closed if the device is not persistent).\n\n```\ncreate() -> {ok, FD, Device}\ncreate(Ifname) -> {ok, FD, Device}\ncreate(Ifname, Flags) -> {ok, FD, Device}\n\n    Types   FD = integer()\n            Device = binary()\n            Flags = list()\n\npersist(FD, Bool) -> ok | {error, posix()}\n\n    Types   FD = integer()\n            Bool = true | false\n\nowner(FD, UID) -> ok | {error, posix()}\n\n    Types   FD = integer()\n            UID = integer()\n\ngroup(FD, GID) -> ok | {error, posix()}\n\n    Types   FD = integer()\n            UID = integer()\n\nup(Device, IPv4Address) -> ok\n\n    Types   Device = binary()\n            IPv4Address = tuple()\n\ndown(Device) -> ok\n\n    Types   Device = binary()\n```","ref":"readme.html#tunctl"},{"type":"extras","title":"EXAMPLES - Overview","doc":"* \"Passive\" mode\n\n  ```\n    1> {ok, Ref} = tuncer:create().\n    {ok, }\n\n    2> tuncer:devname(Ref).\n     >\n\n    3> tuncer:up(Ref, \"192.168.123.4\").\n    ok\n\n    4> FD = tuncer:getfd(Ref).\n    9\n\n    5> {ok, Buf} = tuncer:read(FD, 1500).\n    {ok, >}\n\n    6> tuncer:destroy(Ref).\n    ok\n  ```\n\n* Active mode\n\n  ```\n    1> {ok, Ref} = tuncer:create( >, [tap, no_pi, {active, true}]).\n    {ok, }\n\n    2> tuncer:devname(Ref).\n     >\n\n    3> tuncer:up(Ref, \"192.168.123.4\").\n    ok\n\n    4> flush().\n    Shell got {tuntap, ,\n                       >}\n    Shell got {tuntap, ,\n                       >}\n\n    5> tuncer:destroy(Ref).\n    ok\n  ```\n\n#","ref":"readme.html#examples"},{"type":"extras","title":"vpwn - Overview","doc":"vpwn will set up a point to point tunnel over the Erlang distribution\nprotocol.\n\nCompile vpwn on the source and destination nodes:\n\n```\nerlc -I deps -o ebin examples/*.erl\n```\n\nRun Erlang on the destination node:\n\n```\nerl -pa deps/*/ebin ebin -setcookie OMNOMNOM -name node\n```\n\nAnd on the source node:\n\n```\nerl -pa deps/*/ebin ebin -setcookie OMNOMNOM -name node\n```\n\nThen start up the tunnel (replace the host name):\n\n```\nvpwn:start('node@vpn.example.com', \"10.10.10.1\", \"10.10.10.2\").\n```\n\nThen connect over the tunnel to the second node:\n\n```\nping 10.10.10.2\nssh 10.10.10.2\n```\n\n#","ref":"readme.html#vpwn"},{"type":"extras","title":"Bridging - Overview","doc":"`br` is an example of a simple bridge that floods frames to all the switch\nports. `br` uses a tap device plugged into a Linux bridge as an\nuplink port and 1 or more tap devices as the switch ports.\n\nThis example uses the tap devices as interfaces for Linux containers\n(LXC).\n\n* Create a bridge and attach the physical ethernet interface\n\n```\n# /etc/network/interfaces\niface br0 inet dhcp\n    bridge_ports eth0\n    bridge_stp off\n    bridge_fd 0\n    bridge_maxwait 0\n```\n\n* Start the bridge:\n\n  * `erlbr0` is the name of the tap device connected to the bridge\n  * `erl0, erl1, erl2` are the tap devices used by the containers\n\n```\nbr:start([\"erlbr0\", \"erl0\", \"erl1\", \"erl2\"]).\n```\n\n* In another shell, as root, bring up the uplink and attach it to the bridge:\n\n```\n# ifconfig erlbr0 up\n# brctl addif br0 erlbr0\n# brctl show br0\nbridge name     bridge id               STP enabled     interfaces\nbr0             8000.4aec6d3a44d1       no              erlbr0\n```\n\n* Move the switch port interface into the container. The interface name inside the container will be known as \"erl0\".\n\n```\nlxc.network.type=phys\nlxc.network.link=erl0\nlxc.network.flags=up\n```","ref":"readme.html#bridging"},{"type":"extras","title":"TODO - Overview","doc":"* Linux:\n  * the TUNSETIFF ioctl request to create the interface requires\n    CAP_NET_ADMIN privileges. Look at moving the interface creation\n    into the procket setuid binary for OSes that use the multiplexing\n    dev.\n\n  * add support for tun filtering\n\n* make sure tuncer can never leak file descriptors","ref":"readme.html#todo"},{"type":"extras","title":"LICENSE","doc":"Copyright (c) 2011-2023 Michael Santos  . All\nrights reserved.\n\nRedistribution and use in source and binary forms, with or without\nmodification, are permitted provided that the following conditions\nare met:\n\n1. Redistributions of source code must retain the above copyright notice,\nthis list of conditions and the following disclaimer.\n\n2. Redistributions in binary form must reproduce the above copyright\nnotice, this list of conditions and the following disclaimer in the\ndocumentation and/or other materials provided with the distribution.\n\n3. Neither the name of the copyright holder nor the names of its\ncontributors may be used to endorse or promote products derived from\nthis software without specific prior written permission.\n\nTHIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS\n\"AS IS\" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT\nLIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR\nA PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT\nHOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,\nSPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED\nTO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR\nPROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF\nLIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING\nNEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS\nSOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.","ref":"license.html"}],"content_type":"text/plain"}